import { world, system} from "@minecraft/server";

const blocks7 = ["A","B","C","D","J","M","N","O","Q","T","U","V","W","X","Y","Z"];
const blocks6 = ["E","F","G","H","K","P","R","S","2","4"];
const blocks5 = ["-","_","I","L","0","1","3","5","6","7","8","9"];
const blocks4 = ["(",")"];
const allLengh = blocks7.concat(blocks6,blocks5,blocks4);
const overworld = world.getDimension("overworld")
const sp = " ";

function namePlace (itemName, act, len, block){
	for(let i=0; i<itemName.length; i++)
	{
		let letterLength = 7
		if(!allLengh.includes(itemName[i]) && itemName[i] != " "){letterLength=6 ; len=len-1 ;act.sendMessage(`The Character "${itemName[i]}" is not supported`); continue}
		if(itemName[i] == " "){act.runCommandAsync(`setblock ${block.x-len} 319 ${block.z + 3} mba:black_block`);letterLength=6; len=len-1; continue}
		if(blocks6.includes(itemName[i])){letterLength = 6;}
		if(blocks7.includes(itemName[i])){letterLength = 7;}
		if(blocks5.includes(itemName[i])){letterLength = 5;}
		if(blocks4.includes(itemName[i])){letterLength = 4;}
		act.runCommandAsync(`structure load char:mba_${itemName[i]} ${block.x-len} 319 ${block.z + 3}`);
		len = len - letterLength
	}
}

function bannerName(player){
	const block = player.getBlockFromViewDirection({ maxDistance: 6, includeLiquidBlocks: false, includePassableBlocks: true })?.block
	if (!block?.typeId?.includes("banner")) return;
	let entity = block.dimension.getEntitiesAtBlockLocation({x: block.x, y: block.y + offset(block), z: block.z});
	for (let i=0; i< entity.length; i++){if (!entity[i]) break; entity[i].triggerEvent("name");}
}
function offset(block){if(block.type.id == "minecraft:wall_banner"){return 0.5} else{return 1.5}}
function tag(block, entity){if(block.type.id == "minecraft:wall_banner"){entity.addTag("wall")}}
function offs(sourceEntity){if(sourceEntity.hasTag("wall")){return 0.5} else{return 1.5}}
function nameLength (name){
	let x = 0
	for(let i=0 ; i<name.length; i++){
		if(blocks7.includes(name[i])){x=x+7}
		if(blocks6.includes(name[i])){x=x+6}
		if(blocks5.includes(name[i])){x=x+5}
		if(blocks4.includes(name[i])){x=x+4}
		if(!allLengh.includes(name[i])){x=x+1}
	}return x/2;
}

world.afterEvents.blockPlace.subscribe(event => {
	const player = event.player
	const block = event.block
	const isMap = player.runCommand(`testfor @s[hasitem={item=filled_map,location=slot.weapon.offhand}]`).successCount;
	if (block.dimension.id != "minecraft:overworld" || !isMap || !block.typeId.includes("banner")) return;
	const entity = block.dimension.spawnEntity("mba:dummy_banner", {x: block.x + 0.5, y: block.y + offset(block), z: block.z + 0.5});
	tag(block, entity)
	for(let i=0; i<16; i++){
		const colorObj = world.scoreboard.getObjective(`${player.name}_mbaColor`)
		if (colorObj == undefined) return;
		const itemColor = colorObj.displayName;
		player.runCommandAsync(`structure load banner:banner${itemColor} ${block.x - 4} 319 ${block.z - 10}`)
		entity.addTag(`${itemColor}`);
		break;
	}
	const nameObj = world.scoreboard.getObjective(`${player.name}_mba`)
	if (nameObj == undefined) return;
	let	itemName = nameObj.displayName;
	itemName = itemName.toUpperCase();
	let len = nameLength(itemName)
	entity.nameTag = itemName
	namePlace (itemName, player, len, block)
});

system.afterEvents.scriptEventReceive.subscribe((event) => {
		const{id,sourceEntity,message}=event;
		if(id!= "mba:dummybanner" && message!= "trybuild") return;
		const loc = sourceEntity.location
		const off = offs(sourceEntity)
		const ban = overworld.getBlock({x:loc.x, y:loc.y - off, z:loc.z});
		if (ban.type.id == "minecraft:air"){
			sourceEntity.runCommand(`setblock ${loc.x} 319 ${loc.z + 2} mba:banner_breaking_block`);
			sourceEntity.triggerEvent("despawn");
		}
		const block = overworld.getBlock({x:loc.x, y: 319, z:loc.z});
		if (block.type.id != "minecraft:air") return;
		for (let i=0; i< 16; i++){
			if (sourceEntity.hasTag(`${i}`)){
				sourceEntity.runCommand(`structure load banner:banner${i} ${block.x - 4} 319 ${block.z - 10}`);
				break;
			}
		};
		const nametag = sourceEntity.nameTag
		if(nametag){
			let len = nameLength(nametag)
			namePlace (nametag, sourceEntity, len, block)
		}
});

system.runInterval(() => {
	world.getPlayers().forEach((player) => {
		bannerName(player)
		const isMap = player.runCommand(`testfor @s[hasitem={item=filled_map,location=slot.weapon.offhand}]`).successCount;
		if(!isMap) return;
		const {container} = player.getComponent("minecraft:inventory")
		const Item = container.getItem(player.selectedSlot)
		if (!Item?.typeId?.includes("banner")) return;
		const pName = player.name
		const score = world.scoreboard
		if(score.getObjective(`${pName}_mba`)){score.removeObjective(`${pName}_mba`)}
		const itemName = Item.nameTag;
		if (itemName){score.addObjective(`${pName}_mba`, itemName);}
		for(let i=0; i<16; i++)
		{
			let bannerIds = player.runCommand(`testfor @s[hasitem={item=banner,data=${i},location=slot.weapon.mainhand}]`).successCount;
			if (bannerIds){
				if(score.getObjective(`${pName}_mbaColor`)){score.removeObjective(`${pName}_mbaColor`)}
				score.addObjective(`${pName}_mbaColor`, `${i}`)
				break;
			}
		}
		
	})
});